
package com.company;

import org.apache.camel.builder.AdviceWithRouteBuilder;
import org.apache.camel.test.blueprint.CamelBlueprintTestSupport;
import org.junit.Test;

//public class IsUseAdviceWithJUnit4Test extends org.apache.camel.test.junit4.CamelTestSupport {
public class IsUseAdviceWithJUnit4Test extends CamelBlueprintTestSupport {

	@Test
	public void testIsUseAdviceWith() throws Exception {
		context.getRouteDefinitions().get(0)
				.adviceWith(context, new AdviceWithRouteBuilder() {
					@Override
					public void configure() throws Exception {
						// replace the from with seda:foo
						replaceFromWith("seda:foo");
					}
				});
		// we must manually start when we are done with all the advice with
		context.start();

		getMockEndpoint("mock:result").expectedMessageCount(1);

		template.sendBody("seda:foo", "Hello World");

		assertMockEndpointsSatisfied();
	}

	@Override
	protected String getBlueprintDescriptor() {
		return "./OSGI-INF/blueprint/blueprint.xml";
	}

	@Override
	public boolean isUseAdviceWith() {
		// tell we are using advice with, which allows us to advice the route
		// before Camel is being started, and thus can replace activemq with
		// something else.
		return true;
	}
}